#include "include.h"
#include "macro.h"
//#include "malloc.h"

#define MAX_DATA 65536

typedef struct
{
 ub D[16][4];
} tile;

ul	nbr_tile=0;
tile	TILE[256];

sb cmp_tile(tile a, tile b)
{
 ul i,j;
 for(i=0;i<4;i++)
  for(j=0;j<16;j++)
   if ((a.D)[j][i] != (b.D)[j][i]) return (0);
 return -1;
}

void add_tile(tile t)
{
 ul i,j,k;
 for (i = 0 ; i < nbr_tile ; i++)
	if (cmp_tile(TILE[i],t)) return;
 TILE[nbr_tile++] = t;
}

void main(int argc,char *argv[])
{
 FILE *F1;
 ul num,i,j, x,y,sx, sy;
 ub *buffer;
 ub *a0;
 ub *a1;
 tile t;

/* for(j=0;j<16;j++)
	for(i=0;i<4;i++)
	(t.D)[j][i] = i+4*j;
 F1 = fopen("tesrt.tmp","wb");
 fwrite(&t,sizeof(tile),1,F1);
 fclose(F1);
 return;
*/
 printf("Converting Fargray BIN file to BIN file compatible with "
        "Sprmaker...\n"
        "Don't use any compression & use only 2 plane !\n"
        "Usage: fgtos16 input_file output_file\n");

 if (argc < 3)
     {
      printf("Error : arguments\n");
      return;
     }

 if ((F1 = fopen(argv[1],"rb")) == NULL)
     {
     printf("Error : can't open %s \n",argv[1]);
     return ;
     }

 buffer  = (ub *)xmalloc(sizeof(ub) * MAX_DATA);
 num = fread(buffer, sizeof(ub), MAX_DATA, F1);
 fclose(F1);

 if ((F1 = fopen(argv[2],"wb")) == NULL)
     {
     printf("Error : can't open %s \n",argv[2]);
     free(buffer);
     return ;
     }

 a0 = buffer;
// sx = *(a0 + 6);
// sy = *(a0 + 7);
 if ((*(a0 + 6 ) != 30) || (*(a0+7) != 128))
	{
	printf("Error : illegal size (Must be 240*128)\n");
	return;
	}
 sx = 30;
 sy = 128;
 a0 +=  9;
 a1 = a0 + sx * sy;

 printf("Size : %u x %u\n",sx,sy);

 for(y=0; y < 8 ; y++)
  {
  for (x=0; x < 15 ; x++)
   {
    for(j=0; j < 16 ; j++)
	{
	(t.D)[j][0] = *(a1+0+30*j);
	(t.D)[j][1] = *(a1+1+30*j);
	(t.D)[j][2] = *(a0+0+30*j);
	(t.D)[j][3] = *(a0+1+30*j);
	}
   add_tile(t);
   a0+=2;
   a1+=2;
   }
  a0+=15*30;
  a1+=15*30;
  }
 printf("%u tiles.\n",nbr_tile);
 fwrite(TILE,sizeof(tile),nbr_tile,F1);
 free(buffer);
 fclose(F1);
 printf("Done !\n");
}
