	include	tios.h
	include genlib.h

INC_RATE	EQU	1200

	xdef	_main
	xdef	_comment

	ifne	CALC_TI92PLUS
	xdef	_ti92plus
	xdef	_ti89
	endif

_main:
	jsr	genlib::init		; Init the grey-mode (or gray-mode ?)

	genlib::PUSH_DSCREEN	d0	; Allocate a DSCREEN on the stack (7688 bytes)
	move.l	d0,Screen		; Save its adress
					; you can't allocate more than one screen
	jsr	genlib::init_dscreen	; Allocat a new DScreen for double buffer
	tst.w	d0
	beq	fail			; Memory ?
	move.w	d0,MyHd			; No, save the handle
	move.l	a0,Screen2		; and the adress


	move.l	Screen(PC),d0
	jsr	genlib::set_dscreen_int		; Set the interrupt to this Dscreen
	move.l	Screen2(PC),d0
	jsr	genlib::set_dscreen_function	; Set the functions to this DScreen

	lea	Plane_Table(PC),a3	; Plane 2 table
	sub.l	a5,a5			; No indirect table
	lea	Plane_Tile(Pc),a4	; Tiles adress
	moveq	#5,d3			; Plane is 32=2^5 bytes long
	jsr	genlib::init_plane	; init the plane
	tst.w	d0			; Test : memory ?
	beq	\Error2			; Yes
	move.l	a0,plane2		; Save the adress of the plane

	move.l	plane2(pc),a0		; Select the plane
	move.w	#10,PLANE_XS(a0)		; Set the Scrolling coordinates
	move.w	#20,PLANE_YS(a0)

	move.w	#1,dir3		; Direction x of plane 2
	move.w	#2,dir4		; Direction y of plane 2

	clr.w	temps		; Clear temps of double-buffer

; Generate a dhz buffer
	lea	Dhz_table,a2
	moveq	#SCREEN_Y-1,d0
\llo:		clr.b	(a2)+
		dbf.s	d0,\llo

; Generate a cleared hdz buffer.
	lea	Hdz_table,a2
	moveq	#SCREEN_Y/2-1,d0
\looph:
		clr.l	(a2)+
		dbf.s	d0,\looph

	move.w	#127,var

\Continue:
; Put the plane 2 as background
	move.l	plane2(pc),a0
	jsr	genlib::update_vscreen_16
	lea	Dhz_table,a4
	lea	Hdz_table,a5
	jsr	genlib::put_dhz_plane

; Do the double-buffer
	bsr	double_buffer

; Wait next 30Hz
\wait:	cmp.l	#2,genlib::timer
	bls.s	\wait		
	subq.l	#3,genlib::timer

; A key ?
	; Met a jour les coordonnes du plan
	move.l	plane2(Pc),a0
	move.w	PLANE_YS(a0),d7
	move.w	PLANE_XS(a0),d6

	; Lecture clavier
	jsr	genlib::read_joypad

	; Gestion de Haut/Bas/Gauche/Droite
	btst.l	#right_key,d0
	bne.s	\no_right
		addq.w	#3,d6
\no_right:
	btst.l	#left_key,d0
	bne.s	\no_left
		subq.w	#3,d6
\no_left:
	btst.l	#up_key,d0
	bne.s	\no_up
		subq.w	#3,d7
\no_up:
	btst.l	#down_key,d0
	bne.s	\no_down
		addq.w	#3,d7
\no_down:
	; Sauvegarde les nouvelles coordonnes
	move.l	plane2(pc),a0		; A recharger car detruit par read_joypad (cf doc)
	move.w	d6,PLANE_XS(a0)
	move.w	d7,PLANE_YS(a0)

	; Gestion projection 
	move.w	var(pc),d6
	btst.l	#ka_key,d0
	bne.s	\no_ka
		cmp.w	#8,d6
		ble.s	\no_kb
			subq.w	#1,d6
			bra	\donec
\no_ka:	btst.l	#kb_key,d0
	bne.s	\no_kb
		cmp.w	#128,d6
		bge.s	\no_kb
			addq.w	#1,d6
\donec:			move.w	d6,var
			bsr	Calculate
\no_kb:

	; Test touche ESC
	btst.l	#exit_key,d0
	bne	\Continue		; Esc => On quitte

	move.l	plane2(pc),a0
	jsr	genlib::free_plane	; Free the plane 2
\Error2
	move.w	MyHd(PC),-(a7)
	jsr	tios::HeapFree		; Free the DScreen
	addq.l	#2,a7
fail:
	genlib::POP_DSCREEN		; Pop DScreen
	jsr	genlib::quit		; Disable grey-mode
	rts				; Quit

copy_16:
	moveq	#15,d2
\lopp:
		move.b	d0,(a2)+
		dbf	d2,\lopp
	rts

Calculate:
	movem.l	d0-d7/a0-a6,-(a7)

;\w	bra.s	\w

	moveq	#0,d0
	move.w	var(pc),d0
	move.w	d0,d1
	move.w	d0,d5
	lsr.w	#1,d1
	mulu.w	d0,d0
	sub.w	d1,d0		;D0 = H^2-H/2
	move.l	#128*65536,d2
	fdivu	d0,d2,d3,d4	; d2 = d0.l /d2.w 
	
	move.l	#65536/2,d1	;D1 = V
	clr.l	d0		;D0 = X
	
	lea	X_tab+SCREEN_Y,a1
	subq.w	#1,d5
\loopx:		;Write it 
		swap	d0
		move.b	d0,-(a1)
		swap	d0
		
		; Next
		fadd	d2,d1
		fadd	d1,d0
		dbf	d5,\loopx

	; Calcul de Hdz
	lea	Hdz_table,a0
;	lea	X_tab,a1

	; On vide le debut
	move.w	var(pc),d0
	sub.w	#127,d0
	neg.w	d0
	move.w	d0,d1
	blt.s	\done
\clear:	
;	addq.l	#1,a1
		move.w	#-VIRTUAL_X,(a0)+
		dbf	d0,\clear
\done:
	
	; On raccorde
	moveq	#VIRTUAL_X,d2
;	mulu.w	d2,d1
;	move.w	d1,(a0)+
;	addq.l	#1,a1

	; On calcule le Hdz
	move.w	var(pc),d1
	subq.w	#1,d1
\loop_h
		move.b	(a1)+,d0
		sub.b	(a1),d0
		ext.w	d0
		subq.w	#1,d0
		muls.w	d2,d0
		move.w	d0,(a0)+
		dbf	d1,\loop_h

	movem.l	(a7)+,d0-d7/a0-a6
	rts

double_buffer:
	move.w	temps(pc),d1		; Read temps
	move.l	Screen(pc,d1.w),d0	; Read a screen
	jsr	genlib::set_dscreen_int	; Set the interrupt to this Dscreen
	eor.w	#4,d1			; Next screen
	move.l	Screen(PC,d1.w),d0	; Read the other screen
	jsr	genlib::set_dscreen_function	; Set the functions to this DScreen
	move.w	d1,temps		; Save temps
	rts

MyHd	dc.w	0		; Handle of double-buffer
Screen	dc.l	0		; Screen 1
Screen2	dc.l	0		; Screen 2
temps	dc.w	0		; Temps
plane2	dc.l	0		; Plane 2
dir	dc.w	0		; Dir x1
dir2	dc.w	0		; Dir y1
dir3	dc.w	0		; Dir x2
dir4	dc.w	0		; Dir y2
var	dc.w	0

Plane_Tile:
	incbin "decor.bin"

Plane_Table:
	incbin "pl.lvl"

_comment
	dc.b	"Example 9'",0

	BSS
X_tab
	dcb.b	SCREEN_Y,0
	dcb.b	100,0
Dhz_table:
	dcb.b	SCREEN_Y,0
Hdz_table:
	dcb.w	SCREEN_Y,0
	dcb.b	100,0

	end
